<template>
  <apexchart
    type="candlestick"
    :series="series"
    :options="options"
    height="200px"
  />
</template>

<script>
import ApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: ApexCharts
  },
  data () {
    return {
      options: {
        chart: {
          type: 'candlestick',
          toolbar: {
            show: false
          }
        },
        xaxis: {
          type: 'string',
          tooltip: {
            enabled: false
          }
        },
        yaxis: {
          tooltip: {
            enabled: false
          }
        }
      }
    }
  },
  computed: {
    // チャート用データ
    series () {
      // チャート用データの初期値を宣言する
      const data = []

      // OHLCを取得する
      const ohlc = this.$store.getters['stock/openHighLowClose']

      // 曜日のkey
      const weekList = {
        sun: 'SUN',
        mon: 'MON',
        tue: 'TUE',
        wed: 'WED',
        thu: 'THU',
        fri: 'FRI',
        sat: 'SAT'
      }

      for (const week in weekList) {
        // TODO: なぜか undefined になる
        if (ohlc[week] == undefined) {
          data.push({
            x: weekList[week],
            y: [null, null, null, null]
          })
        } else {
          data.push({
            x: weekList[week],
            y: [
              ohlc[week].open,
              ohlc[week].high,
              ohlc[week].low,
              ohlc[week].close
            ]
          })
        }
      }

      return [{ data: data }]
    }
  }
}
</script>

<style scoped>
</style>
